﻿package com.Tutorial 
{
    import com.adamatomic.flixel.*;
	import flash.geom.Rectangle;
	import com.Tutorial.Mother;
	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class WalkState extends FlxState
	{				
  	
		private var _name:String;
		private var _nameTxt:FlxText;
		private var _playerTxt:FlxText;
		private var _derrida:FlxText;
		private var _star:FlxText;
		private var _spawned:Array;
		
		public function WalkState() 
		{
			_name = "";
			
			_nameTxt = new FlxText(0, 162, FlxG.width, 120, "_", 0xffffffff, null, 18, "center");
			this.add(_nameTxt);
			
			if (NameEntryState._name.length>0)
			{
				_playerTxt = _newText(NameEntryState._name, 20);
				this.add(_playerTxt);				
			}
			else
			{
				_playerTxt = null;
			}
			
			switch (NameEntryState._name.toUpperCase())
			{
				case "STAR":
					FlxG.setMusic(MenuState.Mus4);				
				break;
				case "DERRIDA":
					FlxG.setMusic(MenuState.Mus2);								
				break;
				case "":
					FlxG.setMusic(MenuState.Mus1);								
				break;
				default:
					FlxG.setMusic(MenuState.Mus3);												
				break;
			}
			
		
			_derrida = _newText("DERRIDA", FlxG.width - 90);
			this.add(_derrida);
			
			_star = _newText("STAR", FlxG.width - 35);
			this.add(_star);
			
			_spawned = new Array();
			
			this.add(new FlxSprite(null, 0, 156, false, false, FlxG.width, 1, 0xffffffff));
			this.add(new FlxSprite(null, 0, 158, false, false, FlxG.width, 1, 0xffffffff));

			var offset:Number;
			offset = "a".charCodeAt();
			for (var i:int = 0; i < 26; i++)
			{
				FlxG.setCursor(MenuState.ImgCursor);

				var char:String = String.fromCharCode(offset + i);
				var lb:LetterButton = new LetterButton(char,_addLetter);
				this.add(new FlxButton(
					NameEntryState.leftBorder + 17 * (i%13),
					190 + 19 * Math.floor(i / 13),					
					new FlxSprite(null,0,0,false,false,15,17,0xffffffff),
					lb.action,
					new FlxSprite(null, 0, 0, false, false, 15, 17, 0x000000), 
					new FlxText(0, 0, 15, 17, char, 0xff000000, null, 12, "center"),
					new FlxText(0, 0, 15, 17, char, 0xffffffff, null, 12, "center")
					));
			}
					//add 'back' button

				this.add(new FlxButton(
					NameEntryState.leftBorder + 17 * 7 ,
					190 +19*2,					
					new FlxSprite(null,0,0,false,false,3*17-2,17,0xffffffff),
					_backSpace,
					new FlxSprite(null, 0, 0, false, false, 3*17-2, 17, 0x000000), 
					new FlxText(0, 0, 3*17-2, 17, "del", 0xff000000, null, 12, "center"),
					new FlxText(0, 0, 3*17-2, 17, "del", 0xffffffff, null, 12, "center")
					));
					
					this.add(new FlxButton(
					NameEntryState.leftBorder + 17 * 10 ,
					190 +19*2,					
					new FlxSprite(null,0,0,false,false,3*17-2,17,0xffffffff),
					_done,
					new FlxSprite(null, 0, 0, false, false, 3*17-2, 17, 0x000000), 
					new FlxText(0, 0, 3*17-2, 17, "done", 0xff000000, null, 12, "center"),
					new FlxText(0, 0, 3*17-2, 17, "done", 0xffffffff, null, 12, "center")
					));
		}
		
		private function _newText(s:String, x:Number):FlxText
		{
			var text:FlxText;
			var sp:String = "\n\n\n\n\n\n\n\n\n\n";
			s = s.toUpperCase();
			
			for (var i:int; i < s.length; i++)
			{
				sp = sp.substr(0, 10 - i) + s.charAt(s.length-1-i) + sp.substr(10 - i);
			}
			
			text = new FlxText(x, -10, 20, 200, sp, 0xffffffff, null, 12, "center");
			text.label = s;
			return text;
		}
		private function _updateText():void
		{
			if (_name.length<12)
				_nameTxt.setText(this._name + "_");
			else
				_nameTxt.setText(this._name );				
		}
		
		override public function update():void
        {
			super.update();

			if (FlxG.kLeft && _playerTxt.label!="STAR")
			{
				if (_playerTxt && !_playerTxt.dead)
				{
					if (_playerTxt.x > 0)
					{
						_playerTxt.x -= FlxG.elapsed * 40;
					}
				}
			}
			
			if (FlxG.kRight && _playerTxt.label!="STAR")
			{
				if (_playerTxt && !_playerTxt.dead)
				{
					if (_playerTxt.x < FlxG.width - 20)
					{
						_playerTxt.x += FlxG.elapsed * 40;					
					}
				}
			}
			
			for (var i:int = _spawned.length-1 ; i >=0 ; i--)
			{
				var txt:FlxText = _spawned[i] as FlxText;
				if (!txt.dead)
				{
					txt.x += FlxG.elapsed * 40;
					
					if (txt.x > _derrida.x - 30)
					{						
						if (txt.label == "DERRIDA") 
						{
							if (!_derrida.dead)
							{
								txt.dead = true;
								txt.flicker(0.5);
								_derrida.dead = true;
								_derrida.flicker(0.5);
							}
						}
						else 
						{
							txt.dead = true;
							txt.flicker(0.5);
						}
					}
				}
				else
				{
					if (txt.exists&&!txt.flickering())
					{
						txt.kill();
						FlxG.play(MenuState.Blip, 0.5);	
						_spawned.splice(i, 1);
					}
				}
				
			}
			
			if (_derrida && _playerTxt && !_derrida.dead&&!_playerTxt.dead)
			{
				if (_playerTxt.x > _derrida.x - 30)
				{
					if (_playerTxt.label == "DERRIDA") 
					{
						if (_derrida.exists)
						{
							_playerTxt.dead = true;
							_playerTxt.flicker(0.5);
							_derrida.dead = true;
							_derrida.flicker(0.5);
						}
					}
					else 
					{
						_playerTxt.dead = true;
						_playerTxt.flicker(0.5);
					}	
				}
			}
				
			if (_playerTxt.dead)
			{
				if (_playerTxt.exists && !_playerTxt.flickering())
				{
					_playerTxt.kill();
					FlxG.play(MenuState.Blip, 0.5);	

				}
			}
			
			if (_derrida.dead)
			{
				if (_derrida.exists && !_derrida.flickering())
				{
					_derrida.kill();
					FlxG.play(MenuState.Blip, 0.5);	
				}
			}
			
		}
		
		private function _addLetter( s:String):void
		{
			if (_name.length < 10)
			{
				_name += s;	
				_updateText()
			}
		}
		
		private function _backSpace():void
		{
			if (_name.length > 0)
			{
				_name = _name.substring(0, _name.length - 1);
				_updateText();
			}
		}
		
		private function _done():void
		{
			if (!_playerTxt || _playerTxt.dead || _playerTxt.label=="STAR")
				return;
				
			FlxG.play(MenuState.Blip, 0.5);	

			var txt:FlxText;
			txt = _newText(_name.toUpperCase(), _playerTxt.x + 20);
			_spawned.push(txt);
			this.add(txt);
			
			if (_name.toUpperCase() == "DERRIDA")
			{
				_playerTxt.dead = true;
				_playerTxt.flicker(0.5);
				
				if (_playerTxt.label == "DERRIDA")
				{
					txt.dead = true;
					txt.flicker(0.5);
				}
				
				if (txt.x > _derrida.x - 30)
				{	
					if (!_derrida.dead)
					{
						_derrida.dead = true;
						_derrida.flicker(0.5);
						
						if (!txt.dead)
						{
							txt.dead = true;
							txt.flicker(0.5);							
						}
					}
					FlxG.setMusic(MenuState.Mus5);	
				}
			}
			
			_name = "";
			_updateText();
		}
		
		
	}
}

class LetterButton {
	private var _letter:String;
	private var _clickFunction:Function;
	public function LetterButton(l:String,f:Function)
	{
		_letter = l;
		_clickFunction = f;
	}
	
	public function action():void
	{
		_clickFunction(_letter);
	}
}